
// this :
#include <G4LabTemplateOne/Primary.h>

// Geant4 :
#include <G4ParticleGun.hh>
#include <G4ParticleTable.hh>
#include <G4ParticleDefinition.hh>

G4LabTemplateOne::PrimaryGeneratorAction::PrimaryGeneratorAction(){
  fParticleGun = new G4ParticleGun(1);
  fParticleGun->SetParticleEnergy(1*GeV);
  fParticleGun->SetParticleMomentumDirection(G4ThreeVector(1,0,0));
  fParticleGun->SetParticlePosition(G4ThreeVector(0*cm,0*cm,0*cm));
  G4ParticleTable* particleTable = G4ParticleTable::GetParticleTable();
  if(!particleTable) {
    G4cout << "G4LabTemplateOne::PrimaryGeneratorAction::PrimaryGeneratorAction :"
           << " G4ParticleTable::GetParticleTable() returned 0 !!!" 
           << std::endl;
    return;
  }
  G4ParticleDefinition* particle = particleTable->FindParticle("e-");
  if(!particle) {
    G4cout << "G4LabTemplateOne::PrimaryGeneratorAction::PrimaryGeneratorAction :"
           << " can't find e-." 
           << std::endl;
    int number = particleTable->size();
    G4cout << "G4LabTemplateOne::PrimaryGeneratorAction::PrimaryGeneratorAction :"
           << " known particles (" << number << ") :"
           << std::endl;
    for(int index=0;index<number;index++) {
      G4cout << "   " << particleTable->GetParticleName(index) << std::endl;
    }
    return;
  }
  fParticleGun->SetParticleDefinition(particle);
}
G4LabTemplateOne::PrimaryGeneratorAction::~PrimaryGeneratorAction(){
  delete fParticleGun;
}
void G4LabTemplateOne::PrimaryGeneratorAction::GeneratePrimaries(G4Event* aEvent){
  fParticleGun->GeneratePrimaryVertex(aEvent);
}

