#
# Visualize a detector by using its representation
# done with the HEPVis SoDetectorExample nodekit.
#
# This script could be executed on an OnX Python callback ;
# for example on a MenuItem with :
#    <activate exec="Python">import OnX;OnX.x('OnX_exa_detector')</activate>
# or from the OnX UI Python prompt with :
#   Python> import OnX_exa_detector
# or from the python shell with :
#       OS> <setup OnX>
#       OS> <start Python>
#       >>> import OnX_exa_detector
#

import OnX

import CoinPython as Inventor

import HEPVis

onx_main = None
if OnX.session() == None:  # Start from scratch (for exa from the Python shell)
  import OnX
  onx_main = OnX.run(0,0) # Create the ONXFILE UI but do not ui.steer.
  ui = OnX.session().ui()
  ui.currentPage().currentRegion().clear()  # To clear the OnX banner.
 
ui = OnX.session().ui()
soPage = ui.currentPage()
soPage.title.setValue("Python / Detector")

soRegion = soPage.currentRegion()
soRegion.color.setValue(Inventor.SbColor(0.8,0.8,0.8))
soSep = soRegion.cast_SoDisplayRegion().getStaticScene()

soScale = Inventor.SoScale()
soScale.scaleFactor.setValue(Inventor.SbVec3f(0.1,0.1,0.1))
soSep.addChild(soScale)

soDet = HEPVis.SoDetectorExample()
soSep.addChild(soDet)

del soDet
del soScale
del soSep
del soRegion
del soPage

if onx_main != None:
  ui.show()
  ui.steer()
  del onx_main
  
