#ifndef OnX_Widget_h
#define OnX_Widget_h 

// Inheritance :
#include <Slash/UI/IWidget.h>
#include <Lib/ItemML.h>

namespace Slash {namespace Core {class IWriter;}}
namespace Slash {namespace UI {class IWidgetClass;}}
namespace Slash {namespace UI {class IUI;}}

namespace OnX {

class Widget : public virtual Slash::UI::IWidget, public Lib::ItemML {
public: //Slash::UI::IWidget
  virtual void* cast(const std::string& aTo) const;
  virtual const Slash::UI::IWidgetClass& widgetClass() const;
  virtual std::string name() const;
  virtual void* nativeWidget() const;
  virtual bool executeCallbacks(const std::string&);
  virtual bool size(unsigned int&,unsigned int&);
  virtual bool write(const std::string& file,
                     const std::string& format,
                     const std::string& options = "");
  virtual bool setParameter(const std::string&,const std::string&);
  virtual bool parameterValue(const std::string&,std::string&);
public:
  Widget(Slash::UI::IUI&,
         Lib::ItemMLFactory&,
         Lib::ItemML*,
         Slash::UI::IWidgetClass&);
  virtual ~Widget();
protected:
  Slash::UI::IUI& fUI;
  Slash::UI::IWidgetClass& fWidgetClass;
};

}

#endif
