import OnX
from OnX import *

#/////////////////////////////////////////////////////////////////////////////
# sys procedures :
#/////////////////////////////////////////////////////////////////////////////

def sys_import(aModule):
  import sys
  if sys.modules.has_key(aModule):
    reload(sys.modules[aModule])
  else:
    exec('import %s' % aModule)

def sys_dump_main():
  import sys
  print dir(sys.modules['__main__'])

def sys_exists(name):
  try:
    eval(name)
    return 1
  except NameError:
    return 0

#/////////////////////////////////////////////////////////////////////////////
# session procedures :
#/////////////////////////////////////////////////////////////////////////////

def session_parameterValue(aWhat):
  return session.parameterValue(aWhat)

def ui_parameterValue(aWhat):
  return ui.parameterValue(aWhat)

def session_setColor(aRGB):
  session.setParameter('modeling.color',aRGB)

#/////////////////////////////////////////////////////////////////////////////
# out procedures :
#/////////////////////////////////////////////////////////////////////////////

def out_file(aFile):
  if session.parameterValue('session.helpOnDialog') == 'yes':
    out_file_dialog(aFile)
  else:
    out_file_console(aFile)

def out_file_console(aFile):
  import sys
  input = open(aFile,'r')
  for line in input.readlines() :
    printer.write(line)
  del input

def out_file_dialog(aFile):
  # Expand env variables :
  fname = fmanip.name(aFile)
  #print 'debug : "' + aFile + '" "' + fname + '"'
  import sys
  input = open(fname,'r')
  lines = ''
  for line in input.readlines() :
    lines = lines + line
  del input
  import os
  ui.load('main',os.environ['ONXROOT']+'/scripts/OnX/HelpDialog.onx')
  ui.setParameter('OnX_HelpDialog_text.value',lines)
  ui.show('OnX_HelpDialog_dialog')

#/////////////////////////////////////////////////////////////////////////////
# ui procedures :
#/////////////////////////////////////////////////////////////////////////////

def ui_setFileChooser(aProc,aDirMask='*',aDirectory=''):
  ui.setCallback('fileChooser','ok','Python','ui.hide("fileChooser")\n'+aProc+'(ui.callbackValue().c_str())')
  ui.setCallback('fileChooser','cancel','Python','ui.hide("fileChooser")')
  ui.setParameter('fileChooser.dirMask',aDirMask)
  ui.setParameter('fileChooser.directory',aDirectory)
  ui.setParameter('fileChooser.mode','open')

def ui_setColorChooser():
  ui.setCallback('colorChooser','ok','Python','session_setColor(ui.callbackValue().c_str())')

def ui_setTreeItems(aWidget,aFile):
  import os
  lines = fmanip.read(aFile);
  s = smanip.tostring(lines,'\n')
  ui.setParameter(aWidget+'.items',s)
  del s
  del lines

def ui_currentViewer():
  return ui.session().parameterValue("currentViewer");

def tree_set_from_strings(aParameter,aStrings):
  s = smanip.tostring(aStrings,'\n')
  tree_set(aParameter,s)

def tree_set(aParameter,aString):
  # Example : tree_set('mainTree.items','aa\nbb')
  vs = smanip.lines(aString,vs)
  sout = '<tree>'
  for index in range(0,len(vs)):
    s = vs[index]
    sout += '<treeItem><label>'+s+'</label></treeItem>'
  sout += '</tree>'
  ui.setParameter(aParameter,sout)

#/////////////////////////////////////////////////////////////////////////////
# accessorManager procedures :
#/////////////////////////////////////////////////////////////////////////////

def data_types():
  data_collect('Lib_Type')
  data_dump()

def data_collect(aWhat,aCuts = ''):
  accessorManager.execute('collect',(aWhat,aCuts))

def data_visualize():
  accessorManager.execute('visualize',())

def data_filter(aWhat,aFilter = ''):
  accessorManager.execute('filter',(aWhat,aFilter))

def data_destroy():
  accessorManager.execute('destroy',())

def data_dump(aMode = 'table'):
  accessorManager.execute('dump',(aMode))

def data_number():
  return accessorManager.execute('number',())

def data_set(aWhat,aValue):
  accessorManager.execute('set',(aWhat,aValue))

def data_values(aWhat):
  return accessorManager.execute('values',(aWhat))

#/////////////////////////////////////////////////////////////////////////////
# viewer procedures :
#/////////////////////////////////////////////////////////////////////////////

def viewer_collect():
  data_collect('SceneGraph','highlight==true')
  data_filter('name')
  data_dumpMode = session_parameterValue('AccessorManager.dumpMode')
  data_dump(data_dumpMode)

def viewer_popup():
  item = ui.callbackValue()
  if item == "Current region" :
    x = ui.callbackData().x()
    y = ui.callbackData().y()
    index = ui.currentPage().positionRegion(x,y)
    ui.currentPage().setCurrentRegion(index)
  elif item == "No highlighted" :
    ui.currentPage().setParameter('highlighted','off')

#/////////////////////////////////////////////////////////////////////////////
# SoPage procedures :
#/////////////////////////////////////////////////////////////////////////////
def ui_SoPage(aUI):
  widget = ui.findWidget(ui.currentViewer().c_str())
  assert widget
  pageViewer = IWidget_to_IPageViewer(widget)
  assert pageViewer
  return pageViewer.soPage()

def sopage_setCurrentRegion(aPage,aIndex):
  soRegion = aPage.getRootRegion(aIndex)
  if soRegion == 0 : return
  aPage.highlightRegion(soRegion)

def sopage_currentRegion(aPage):
  highlighted = aPage.getHighlightedRegion()
  assert highlighted
  if aPage.isRootRegion(highlighted) == 0 : return 0
  return highlighted

def sopage_createRegion(aPage,aClass,aX,aY,aWidth,aHeight):
  soRegion = aPage.createRegion(SbString(aClass),aX,aY,aWidth,aHeight)
  if aPage.getNumberOfRootRegions() == 1 : aPage.highlightRegion(soRegion)
  return soRegion

#/////////////////////////////////////////////////////////////////////////////
# SoRegion procedures :
#/////////////////////////////////////////////////////////////////////////////

def soregion_staticNode(aRegion):
  soNode = aRegion.cast_SoDisplayRegion()
  if soNode == 0 : return 0
  return soNode.getStaticScene()

def soregion_dynamicNode(aRegion):
  soNode = aRegion.cast_SoDisplayRegion()
  if soNode == 0 : return 0
  return soNode.getDynamicScene()

def soregion_readInventorFile(aRegion,aFile):
  name = fmanip.name(aFile)
  soInput = SoInput()
  if soInput.openFile(name) == 0 : return
  soSep = SoDB_readAll(soInput)
  if soSep == 0 : return
  doIt = SbAddNode(soSep,SbString("staticScene"))
  if aRegion.doIt(doIt) == 0 : 
    soSep.unref()
    return

#/////////////////////////////////////////////////////////////////////////////
# Inventor procedures :
#/////////////////////////////////////////////////////////////////////////////

def iv_dumpNode( aNode ):
  ss = SbString('')
  aNode.get(ss)
  ui.echo(ss.getString())
  del ss

def sokit_parameterValue(aNode,aWhat):
  ss = SbString(aWhat)
#FIXME : below crashes with Coin
#  aNode.get(ss)
  SoTools_getKitPartValue(aNode,SbString(aWhat),ss)
  return ss.getString()

