#
#  From the Python shell :
#   OS> <setup OnXLab>
#   OS> <start python>
#  (>>> import AIDA)
#   >>> import OnXLab_exa_aida_10
#

#
# Functions.
#

import AIDA

aida = AIDA.createAnalysisFactory()
tf = aida.createTreeFactory()
tree = tf.create()
del tf

functionFactory = aida.createFunctionFactory(tree)

plotterFactory = aida.createPlotterFactory()
plotter = plotterFactory.create('')
del plotterFactory
plotter.createRegions(1,1,0)
plotter.setTitle('Functions')

region = plotter.currentRegion()
func = functionFactory.createFunctionFromScript('scriptedFunction',1,'sin(x)','','','')
func.setTitle('sin(x)')
region.plot(func)

gaussian = functionFactory.createFunctionByName('gaussian','G')
gaussian.setTitle('Gaussian')
gaussian.setParameter("amplitude",0.8)
gaussian.setParameter("mean",0)
gaussian.setParameter("sigma",0.5)
region.plot(gaussian)

bw = functionFactory.createFunctionByName('breitWigner','BW')
bw.setTitle('Breit Wigner')
bw.setParameter("amplitude",0.8)
bw.setParameter("origin",0)
bw.setParameter("width",0.5)
region.plot(bw)

exp = functionFactory.createFunctionByName('exponential','E')
exp.setTitle('Exponential')
exp.setParameter("amplitude",0.4)
exp.setParameter("exponent",1)
region.plot(exp)

region.plot(gaussian)
region.setParameter('plotter.xAxisAutomated','FALSE')
region.setParameter('plotter.xAxisMinimum','-10')
region.setParameter('plotter.xAxisMaximum','10')

plotter.show()
plotter.interact()

del plotter
del bw
del gaussian

del functionFactory
del tree
del aida
