import AIDA
import random

aida = AIDA.createAnalysisFactory()

# Factories :
plotterFactory = aida.createPlotterFactory()
treeFactory = aida.createTreeFactory()
memoryTree = treeFactory.create()
functionFactory = aida.createFunctionFactory(memoryTree)
histogramFactory = aida.createHistogramFactory(memoryTree)

# Get current plotter :
plotter = plotterFactory.create('')

plotter.createRegions(1,2,0)

plotter.setTitle('Convert')

# 0 = read only false
# 1 = create new
rioTree = treeFactory.create('tuple.root','ROOT',0,1)

rioTupleFactory = aida.createTupleFactory(rioTree)

tuple = rioTupleFactory.create('tuple','tuple','float rand_gauss,float rand_flat')

r = random.Random()
for I in range(0,10000):
 tuple.fill(0,r.gauss(0,1))
 tuple.fill(1,r.random())
 tuple.addRow()
del r

rioTree.commit()
rioTree.ls()

evaluator = rioTupleFactory.createEvaluator('rand_gauss')
filter = rioTupleFactory.createFilter('')

function = tuple.convertToFunction(functionFactory,"functionFromTuple","Tuple to function convertion","",evaluator,filter) #OnXLab SWIG extension.
del evaluator
del filter

region = plotter.currentRegion()
region.plot(function)

region.setParameter('plotter.xAxisAutomated','FALSE')
region.setParameter('plotter.xAxisMinimum','0')
region.setParameter('plotter.xAxisMaximum','10000')

evaluatorX = rioTupleFactory.createEvaluator('rand_gauss')
evaluatorY = rioTupleFactory.createEvaluator('rand_flat')
filter = rioTupleFactory.createFilter('')

cloud = tuple.convertToCloud(histogramFactory,"cloudFromTuple","Tuple to cloud convertion",evaluatorX,evaluatorY,filter) # OnXLab SWIG extension.
del evaluatorX
del evaluatorY
del filter

region = plotter.next()
region.plot(cloud)

plotter.show()
plotter.interact()

del function
del cloud
del plotter
del tuple
del rioTree

del plotterFactory
del treeFactory
del rioTupleFactory
del functionFactory
del histogramFactory

del aida
